#:import logging logging
#:import IPVersion zeroconf.IPVersion
#:import SlideTransition kivy.uix.screenmanager.SlideTransition
#:import SwapTransition kivy.uix.screenmanager.SwapTransition
#:import FadeTransition kivy.uix.screenmanager.FadeTransition
#:import Svg kivy.graphics.svg.Svg

# UTILS

<Space@Widget>

<BackgroundColor@Widget>:
  background_color: 1, 1, 1, 1
  canvas.before:
    Color:
      rgba: root.background_color
    Rectangle:
      size: self.size
      pos: self.pos

# NODES WIDGET

<Nodes@BoxLayout>:
  orientation: "vertical"
  Selectors:
    id: selectors
  Display:
    id: display

<Selectors@BoxLayout>:
  size: 0, 34
  size_hint: 1, None
  padding: 0, 8
  Space:
  Space:
  Selector:
    text: "Plan"
    on_press:
      sm = app.root.ids.nodes.ids.display
      sm.current = "plan"
  Selector:
    text: "Liste"
    on_press:
      sm = app.root.ids.nodes.ids.display
      sm.current = "list"
  Space:
  Space:

<Selector@Button>:
  color: 1, 1, 1
  size: self.texture_size[0], 24
  size_hint: None, None
  padding: 12, 0

<Display@ScreenManager>:
  transition: FadeTransition()
  Screen:
    name: "plan"
    Image:
      source: "assets/png/plan.png"
  Screen:
    name: "list"

  # Button:
  #   size_hint_x: None
  #   text: "Activation"
  #   on_press:
  #     app.osc.sendMessage("/logs/activate", 9001)
  # Button:
  #   size_hint_x: None
  #   text: "Désactivation"
  #   on_press:
  #     app.osc.sendMessage("/logs/deactivate", [])

# CONSOLE WIDGET

<Filter@Button>:
  size: 34, 34
  size_hint: None, None

<Console>:
  orientation: "vertical"
  BoxLayout:
    id: header
    orientation: "horizontal"
    size: 0, 42
    size_hint: 1, None
    Label:
      id: title
      text: "[b]Console[/b]"
      text_size: self.width, None
      size_hint: 1, 1
      markup: True
      font_size: 24
    BoxLayout:
      orientation: "horizontal"
      Space:
      Filter:
        canvas.after:
          Rectangle:
            pos: self.pos[0] + 4.5, self.pos[1] + 4.5
            size: self.size[0] - 8, self.size[1] - 8
            source: "assets/icons/logs/all.png"
        on_press:
          root.filter(None)
      Filter:
        canvas.after:
          Rectangle:
            pos: self.pos[0] + 4.5, self.pos[1] + 4.5
            size: self.size[0] - 8, self.size[1] - 8
            source: "assets/icons/logs/info.png"
        on_press:
          root.filter(logging.INFO)
      Filter:
        canvas.after:
          Rectangle:
            pos: self.pos[0] + 4.5, self.pos[1] + 4.5
            size: self.size[0] - 8, self.size[1] - 8
            source: "assets/icons/logs/warning.png"
        on_press:
          root.filter(logging.WARNING)
      Filter:
        canvas.after:
          Rectangle:
            pos: self.pos[0] + 4.5, self.pos[1] + 4.5
            size: self.size[0] - 8, self.size[1] - 8
            source: "assets/icons/logs/error.png"
        on_press:
          root.filter(logging.ERROR)
      Filter:
        canvas.after:
          Rectangle:
            pos: self.pos[0] + 4.5, self.pos[1] + 4.5
            size: self.size[0] - 8, self.size[1] - 8
            source: "assets/icons/logs/critical.png"
        on_press:
          root.filter(logging.CRITICAL)
  ConsoleView:
    padding: 2, 8
    ScrollView:
      id: drawer
      do_scroll_x: False
      do_scroll_y: True
      size_hint_y: 1
      size: root.size
      pos: root.pos
      padding: 12
      Label:
        id: logs
        height: self.texture_size[1]
        size_hint_y: None
        text_size: self.width, None
        markup: True
        padding_x: 8

# USER INTERFACE WIDGET

<UserInterface>:
  transition: SlideTransition(direction="left")
  Screen:
    name: "home"
    BoxLayout:
      # canvas.before:
      #   Color:
      #     rgba: 0,0,0,1
      #   Rectangle:
      #     size: self.size
      #     pos: self.pos
      orientation: "vertical"
      padding: 12
      BoxLayout:
        id: header
        size: (0, 42)
        size_hint: (1, None)
        Label:
          id: title
          font_size: 24
          bold: True
          halign: "left"
          text: "SATOSPHÈRE"
          text_size: self.size
          valign: "middle"
        HelpButton:
          id: help
          text: "?"
          size: 42, 42
          size_hint: None, None
      Nodes:
        id: nodes
        size_hint_y: .6
      Console:
        id: console
        size_hint_y: .4
      BoxLayout:
        id: toolbar
        size: (0, 42)
        size_hint: (1, None)
        CalibrateButton:
          size_hint_x: None
          text: "Démarrer"
        Space:
        SettingsButton:
          text: "Paramètres"
          size_hint_x: None
          on_press:
            root.transition.direction = "left"
            root.current = "settings"

  Screen:
    name: "registry"

  Screen:
    name: "settings"
    BoxLayout:
      orientation: "vertical"
      padding: 8
      BoxLayout:
        size_hint_y: None
        size: 0, 32
        Label:
          text: "Paramètres"
        Button:
          text: "x"
          size: 32, 0
          size_hint_x: None
          on_press:
            root.transition.direction = "right"
            root.current = "home"
      BoxLayout:
        id: instance_name
        orientation: "vertical"
        size_hint_y: None
        size: 0, 64
        Label:
          id: label
          padding: 5, 2.5
          text_size: self.size
          halign: "left"
          text: "Nom d'instance"
        TextInput:
          id: field
          text: "SATOSPHÈRE"
      BoxLayout:
        id: osc_host
        orientation: "vertical"
        size_hint_y: None
        size: 0, 64
        Label:
          id: label
          padding: 5, 2.5
          text_size: self.size
          halign: "left"
          text: "Adresse OSC"
        TextInput:
          id: field
          text: "192.168.0.42"
      Widget:
      BoxLayout:
        size: (0, 42)
        size_hint: (1, None)
        Button:
          text: "Annuler"
          size_hint_x: None
          on_press:
            root.transition.direction = "right"
            root.current = "home"
        Widget:
        Button:
          text: "Valider"
          size_hint_x: None
          on_press:
            root.ids.header.ids.title.text = root.ids.instance_name.children[0].text
            root.transition.direction = "right"
            root.current = "home"
